#include <GUIConstants.au3>
#include <File.au3>
#include <Sound.au3>


; Program and design by Colin (www.ctg3d.tk)
; Version 3
;
; Originally the plan was to match the moves with the beat,
; however beat detection is difficult. There is a possible
; method with AUDACITY and it's beat finder. You can save
; the beats out to a text file. Then parse the file with
; Autoit. Another feature is an MP3 length finder and
; progress bar that I am not sure how to make.
;
; Joystick controls by:
;      Original program by Ejoc 
;      Improved by Adam1213 (autoit 3.2 compatiblity + improved labels
;   * Found on the autoit forum *
;
;
; Warning: don't steal this code and call it your own with no mention
;  of me whatsoever.. if you are to compile it, please include my name
;  (DerBen) and website (www.ctg3d.tk) in a readme file along with
;  the information for the joystick function programmers.
;
;     -Thanks, DerBen
;


;_________________ Variables
; * Nothing here needs changing *

Dim $szDrive, $szDir, $szFName, $szExt
dim $moves[6] = ["","","","",""]
dim $arrows[6][6]

$sound=""
$mp3=""
$rnd=""
$easy="on"
$beat="off"
$begin=0
$arrow=""
$up = "u"
$dn = "d"
$lf = "l"
$rt = "r"
$total = 0
$score = 0
;$resx=@desktopwidth
;$resy=@desktopheight
$pressed=""
$prev=""

;_________________ Joy SETUP

Local $joy,$coor,$h,$s,$msg

$joy    = _JoyInit()

dim $labels_text[8]=['X', 'Y', 'Z', 'R', 'U', 'V', 'POV', 'Buttons']
dim $labels_no=UBound($labels_text)
dim $labels[$labels_no]
dim $labels_value[$labels_no]
;__________ Joy CONFIG
;---------- Find the max length of the longest label --------------
$label_len=0
for $text in $labels_text
    $len=stringlen($text)
    if $len>$label_len then
        $label_len=$len
    endif
next
$label_len*=6

;__________ Program

Opt("MouseCoordMode", 0)
HotKeySet("{ESC}", "Terminate")



$Gui = GUICreate("DerBens Digital Dancer", 800, 600)
GUISetBkColor (0x000000)
GUISetIcon ("rainbow.ico")
$pp=GUICreate("", 800, 600, -1, -1,$WS_POPUP,BitOr($WS_EX_LAYERED,$WS_EX_MDICHILD),$Gui)

GUICtrlCreatePic ( "DerbDancePad.jpg", 100, 0,600,600 )
GUISetBkColor (0x000000)

$input = GUICtrlCreateinput ( "<<< No MP3 - Click Open <<<",175, 50, 450 ,25 )
$input2 = GUICtrlCreateinput ( "Score",10, 215, 80 ,25 )
$input3 = GUICtrlCreateinput ( "Count",10, 260, 80 ,25 )
$button_1 = GUICtrlCreatebutton ("&OPEN",10,50,80,50)
;$button_2 = GUICtrlCreatebutton ("&Config",710,100,80,50)
$button_2 = "22222222222222222222"
$button_3 = GUICtrlCreatebutton ("&Info",710,125,80,50)
$button_4 = GUICtrlCreatebutton ("&Reset",10,325,80,50)
$check_2 = GUICtrlCreatecheckbox ("&Beat",710,325,80,50,$BS_PUSHLIKE)
$check_1 = GUICtrlCreateCheckbox ("&Advanced",710,425,80,50,$BS_PUSHLIKE)
;$bar = GUICtrlCreateProgress(200,80.,400,15)
$bar = GUICtrlCreateProgress(150,80.,500,15)  ; << BUG??!?!

$row=10
$col=110
For $x = 5 to 1 Step -1
 $row = $row+100
 For $y = 1 to 4 Step 1
  $col =$col +100
  $arrows[$x][$y] = GUICtrlCreatePic("x.bmp", $col, $row,80,80 )
 next
 $col=110
next

GUISetState(@SW_SHOW,$pp)
GUISetState(@SW_SHOW,$gui)


While 1

 $msg = GUIGetMsg($gui)
 Select
  Case $msg = $GUI_EVENT_CLOSE
    ExitLoop

  Case $msg = $check_1
   if $easy="off" then
    $easy="on"
   else
    $easy="off"
   endif

  Case $msg = $button_3
   msgbox(0,"DerBens Digital Dancer - Version 3","This game was designed because of the lack of known songs available with other dance games. Now you can dance to any MP3 on your PC, provided you have a dance mat. You can use any mat with your PC, with the right adaptor. USB Adaptors for popular console mats (DDR compatable) can be found on ebay."&@cr&@cr&"-Beat Mode- lets you dance at your own pace. Not Timed." &@cr& "-Easy mode- uses only UP, LEFT, RIGHT, DOWN, LEFT+RIGHT."&@cr&"-Advanced mode- adds moves like UP+LEFT, UP+RIGHT and DOWN+RIGHT"&@cr&@cr&"-DerBen")

  Case $msg = $button_4
   if $mp3 then $total = 5
   if not $mp3 then $total=0
   $score=0

  Case $msg = $check_2
   if $beat="off" then
    $beat="on"
   else
    $beat="off"
   endif

  Case $msg = $button_1
    $tmp = FileOpenDialog ( "Pick a Music File", "mp3", "Music (*.mp3;*.wav)",3)
    if $tmp not = "" then
     $mp3 = $tmp
     $tmp = _PathSplit ($tmp,$szDrive, $szDir, $szFName, $szExt)
     $tmp= $tmp[3] & $tmp[4]
     GUICtrlSetData ($input,$tmp)
     
     FileChangeDir (@ScriptDir)
     ;soundplay($mp3,0)
     $sound = _SoundOpen($mp3)
     _SoundPlay($sound)
   SLEEP(1000)

     For $i = 5 to 1 Step -1
      $moves[$i] = ""
     next
     $begin = TimerInit()
    endif

  Case $msg = $button_2
   config()   

  Case $msg = $GUI_EVENT_PRIMARYDOWN
   $pos = MouseGetPos()
   $pos[1] =$pos[1]-23
   $pos[0] =$pos[0]-3
   
  Case $mp3 not = ""
   if $beat = "on" and $moves[4] = "" then
    $total=$total+1
    arrow()
   endif


   if $beat = "off" then

    $dif = TimerDiff($begin)
    if $dif > 800 then

     if $total > 0 then
      $scorepct = number($score/$total)
      $scorepct = round($scorepct*100,1)
      GUICtrlSetData ($input2,"Score: "&$scorepct&"%")
      GUICtrlSetData ($input3,$score&"/"&$total)
     endif

     $moves[4] = StringReplace ($moves[4],"u","1")
     $moves[4] = StringReplace ($moves[4],"l","2")
     $moves[4] = StringReplace ($moves[4],"d","3")
     $moves[4] = StringReplace ($moves[4],"r","4")
     ;tooltip($moves[3])
     if $moves[3] <> "" then 
      $total=$total+1
     endif
     arrow()
     $begin = TimerInit()
    endif
  endif
endselect

$dif = TimerDiff($begin)
if $dif > 50 then

 $play = ""

 $tmp = press()

select
 case $tmp = $lf
  $play = "l"
 case $tmp = $up
  $play = "u"
 case $tmp = $dn
  $play = "d"
 case $tmp = $rt
  $play = "r"
 case $tmp = $lf&$rt
  $play = "lr"
 case $tmp = $up&$dn
  $play = "ud"
 case $tmp = $up&$lf
  $play = "ul"
 case $tmp = $up&$rt
  $play = "ur"
 case $tmp = $dn&$lf
  $play = "dl"
 case $tmp = $dn&$rt
  $play = "dr"
endselect

 if $play then

  if $play = $moves[4] then
   $moves[4] = StringReplace ($moves[4],"u","w")
   $moves[4] = StringReplace ($moves[4],"l","x")
   $moves[4] = StringReplace ($moves[4],"d","y")
   $moves[4] = StringReplace ($moves[4],"r","z")
   $play =""
   draw()
   $score = $score+1
   if $beat = "on" then
    $total=$total+1
    arrow()
   endif
  endif
 endif
endif

if $sound then
 $pct = round((_soundPos($sound,2)/_SoundLength($sound,2))*100)
 GUICtrlSetData ($bar,$pct)
endif

if $mp3 <> "" and $pct > 99.9 then
 $mp3 = ""
 GUICtrlSetData ($input,"<< Click Open")
 _SoundClose($sound)
endif
Wend

;__________ Functions

func config()

 $cfg = GUICreate("DDDancer Config", 200,300,-1,-1,-1,-1,$gui)
 GUICtrlCreatelabel ("Step on direction and press button"&@CR&"that corresponds below.",10,5,280,40)
 $inp1 = GUICtrlCreatebutton ( $up,100, 50, 80 ,25 )
 $inp2 = GUICtrlCreatebutton ( $dn,100, 100, 80 ,25 )
 $inp3 = GUICtrlCreatebutton ( $lf,100, 150, 80 ,25 )
 $inp4 = GUICtrlCreatebutton ( $rt,100, 200, 80 ,25 )
 $inp5 = GUICtrlCreatebutton ( "&Close",50, 250, 80 ,25 )
 GUICtrlCreateLabel ( "UP", 5, 50)
 GUICtrlCreateLabel ( "DOWN", 5, 100)
 GUICtrlCreateLabel ( "LEFT", 5, 150) 
 GUICtrlCreateLabel ( "RIGHT", 5, 200) 
 GUISetState (@SW_SHOW)

tooltip("")

While 1

 $msg = GUIGetMsg($cfg)
 Select
  Case $msg = $GUI_EVENT_CLOSE
   guidelete($cfg)  
   ExitLoop

  Case $msg = $inp1
   tooltip("Press UP") 
   $up= press()
   GUICtrlSetData ($inp1,$up)
   tooltip("")
  Case $msg = $inp2
   tooltip("Press DOWN")
   $dn = press()
   GUICtrlSetData ($inp2,$dn)
   tooltip("")
  Case $msg = $inp3
   tooltip("Press LEFT")
   $lf = press()
   GUICtrlSetData ($inp3,$lf)
   tooltip("")
  Case $msg = $inp4
   tooltip("Press RIGHT")
   $rt = press()
   GUICtrlSetData ($inp4,$rt)
   tooltip("")
  Case $msg = $inp5
   guidelete($cfg)  
   ExitLoop
 endselect
wend


endfunc



func press()
 $pressed = ""
    $coord=_GetJoy($joy,0)
    if $coord[1] = 32767 then
     $pressed = "ud"
    elseif $coord[1] < 30000 then
     $pressed = $pressed &"u"
    elseif $coord[1] > 33000 then
     $pressed = $pressed &"d"
    endif

    if $coord[0] = 32767 then
     $pressed = "lr"
    elseif $coord[0] < 30000 then
     $pressed = $pressed &"l"
    elseif $coord[0] > 33000 then
     $pressed = $pressed &"r"
    endif

  if $prev not = "" and stringlen($moves[4]) not = 2 then
   $pressed = ""
  endif

  $prev = "x"
  $coord=_GetJoy($joy,0)
   $coord=_GetJoy($joy,0)
   if $coord[0] < 33000 and $coord[0] > 30000 then 
    if $coord[1] < 33000 and $coord[1] > 30000 then 
     if $coord[7] = 0 then
      if $coord[0] <> 32767 and $coord[1] <> 32767 then
       $prev=""
      endif
     endif
    endif
   endif
  return $pressed
endfunc


Func Terminate()
    Exit 0
EndFunc

func arrow()
;tooltip($pct)
 if $pct < 90 then
  if $easy="on" then
   $prv = $rnd
   $rnd = StringLeft (5* random(0,1),1)+1
   if $prv = 5 and $rnd = 5 then
    $rnd = StringLeft (2* random(0,1),1)+1
    $rnd = $rnd + StringLeft (2* random(0,1),1)
   endif
  else
   $rnd = StringLeft (10* random(0,1),1)+1
  endif
 else
  $rnd=0
 endif
  select
  case $rnd = 0
   $arrow = ""
  case $rnd = 1
   $arrow = "u"
  case $rnd = 2
   $arrow = "l"
  case $rnd = 3
   $arrow = "r"
  case $rnd = 4
   $arrow = "d"
  case $rnd = 5
   $arrow = "lr"
  case $rnd = 6
   $arrow = "ud"
  case $rnd = 7
   $arrow = "ur"
  case $rnd = 8
   $arrow = "ul"
  case $rnd = 9
   $arrow = "dr"
  case $rnd = 10
   $arrow = "dl"
  endselect


 $moves[5] = $moves[4]
 $moves[4] = $moves[3]
 $moves[3] = $moves[2]
 $moves[2] = $moves[1]
 $moves[1] = $arrow

 draw()
endfunc

func draw ()
 $row=510
 $col=110
For $x = 5 to 1 Step -1
 $row = $row-100
For $y = 1 to 4 Step 1
 $col = $col+100

 $word="x"

if ($y=2) then
 if stringinstr($moves[$x],"u")  then $word="Wu"
 if stringinstr($moves[$x],"w")  then $word="Gu"
 if stringinstr($moves[$x],"1")  then $word="Ru"
endif

if ($y=1) then
 if stringinstr($moves[$x],"l") then  $word="Wl"
 if stringinstr($moves[$x],"x") then  $word="Gl"
 if stringinstr($moves[$x],"2") then  $word="Rl"
endif

if ($y=3) then
 if stringinstr($moves[$x],"d") then $word ="Wd"
 if stringinstr($moves[$x],"y") then $word ="Gd"
 if stringinstr($moves[$x],"3") then $word ="Rd"
endif

if ($y=4) then
 if stringinstr($moves[$x],"r") then $word="Wr"
 if stringinstr($moves[$x],"z") then $word="Gr"
 if stringinstr($moves[$x],"4") then $word="Rr"
endif

  GUICtrlSetImage($arrows[$x][$y],$word & ".bmp")

next
$col=110
next

endfunc

;======================================
;   _JoyInit()
;======================================
Func _JoyInit()
    Local $joy
    Global $JOYINFOEX_struct    = "dword[13]"

    $joy=DllStructCreate($JOYINFOEX_struct)
    if @error Then Return 0
    DllStructSetData($joy, 1, DllStructGetSize($joy), 1);dwSize = sizeof(struct)
    DllStructSetData($joy, 1, 255, 2)            ;dwFlags = GetAll
    return $joy
EndFunc

;======================================
;   _GetJoy($lpJoy,$iJoy)
;   $lpJoy Return from _JoyInit()
;   $iJoy  Joystick # 0-15
;   Return Array containing X-Pos, Y-Pos, Z-Pos, R-Pos, U-Pos, V-Pos,POV
;         Buttons down
;
;         *POV This is a digital game pad, not analog joystick
;         65535  = Not pressed
;         0    = U
;         4500   = UR
;         9000   = R
;         Goes around clockwise increasing 4500 for each position
;======================================
Func _GetJoy($lpJoy,$iJoy)
    Local $coor,$ret

    Dim $coor[8]
    DllCall("Winmm.dll","int","joyGetPosEx", _
            "int",$iJoy, _
            "ptr",DllStructGetPtr($lpJoy))

    if Not @error Then
        $coor[0]    = DllStructGetData($lpJoy,1,3)
        $coor[1]    = DllStructGetData($lpJoy,1,4)
        $coor[2]    = DllStructGetData($lpJoy,1,5)
        $coor[3]    = DllStructGetData($lpJoy,1,6)
        $coor[4]    = DllStructGetData($lpJoy,1,7)
        $coor[5]    = DllStructGetData($lpJoy,1,8)
        $coor[6]    = DllStructGetData($lpJoy,1,11)
        $coor[7]    = DllStructGetData($lpJoy,1,9)
    EndIf

    return $coor
EndFunc